src/waves/accounts/urls.py
from __future__ import unicode_literals
from django.conf.urls import include, url
from django.views.generic import TemplateView

import waves.views.accounts

urlpatterns = [
    url(r'^activate/complete/$',
        waves.views.accounts.ActivationView.as_view(template_name='accounts/activation_complete.html'),
        name='registration_activation_complete'),
    url(r'^activate/(?P<activation_key>[-:\w]+)/$',
        waves.views.accounts.ActivationView.as_view(),
        name='registration_activate'),
    url(r'^register/$',
        waves.views.accounts.SignUpView.as_view(),
        name='registration_register'),
    url(r'^register/complete/$',
        TemplateView.as_view(template_name='accounts/registration_complete.html'),
        name='registration_complete'),
    url(r'^register/closed/$',
        TemplateView.as_view(template_name='accounts/registration_closed.html'),
        name='registration_disallowed'),
    url(r'^login/$', waves.views.accounts.LoginView.as_view(), name="login"),
    url(r'^logout/$', waves.views.accounts.LogoutView.as_view(), name='logout'),
    url(r'^signup/$', waves.views.accounts.SignUpView.as_view(), name='signup'),
    url(r'^password/change/$', waves.views.accounts.PasswordChangeView.as_view(), name='password-change'),
    url(r'^password/reset/$', waves.views.accounts.PasswordResetView.as_view(), name='password-reset'),
    url(r'^password/reset/done/$', waves.views.accounts.PasswordResetDoneView.as_view(), name='password-reset-done'),
    url(r'^password/reset/(?P<uidb64>[0-9A-Za-z_\-]+)/(?P<token>[0-9A-Za-z]{1,13}-[0-9A-Za-z]{1,20})/$$',
        waves.views.accounts.PasswordResetConfirmView.as_view(),
        name='password-reset-confirm'),
]

src/waves/profiles/urls.py
from __future__ import unicode_literals
from django.conf.urls import url
import waves.views.profiles

urlpatterns = [
    url(r'^me$', waves.views.profiles.ShowProfile.as_view(), name='show_self'),
    url(r'^me/edit$', waves.views.profiles.EditProfile.as_view(), name='edit_self'),
    url(r'^(?P<slug>[\w\-]+)$', waves.views.profiles.ShowProfile.as_view(),
        name='show'),
]

src/waves/urls/urls.py
from __future__ import unicode_literals

from django.conf.urls import url
from django.conf.urls import include
from waves.views.base import *

urlpatterns = [
    url(r'^$', HomePage.as_view(), name='home'),
    url(r'^accounts/', include('waves.urls.accounts_url')),
    url(r'^api/', include('waves.urls.api_urls')),
    url(r'^admin/', include('waves.urls.back_urls')),
    url(r'^waves/', include('waves.urls.front_urls'))
]

src/waves_services/urls.py
from __future__ import unicode_literals

from django.conf import settings
from django.conf.urls import include, url
from django.conf.urls.static import static
from django.contrib import admin

urlpatterns = [
    url(r'^', include('waves.urls.urls', namespace='waves')),
    url(r'^nested_admin/', include('nested_admin.urls')),
    url(r'^grappelli/', include('grappelli.urls')),  # grappelli URLS
    url(r'^admin/', include(admin.site.urls)),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

src/waves/models/samples.py
from __future__ import unicode_literals
from django.db import models


def service_sample_directory(instance, filename):
    return 'sample/{0}/{1}'.format(instance.service.api_name, filename)


class ServiceInputSample(models.Model):
    class Meta:
        ordering = ['name']
        db_table = 'waves_service_sample'
        unique_together = ('name', 'input', 'service')

    name = models.CharField('File name', max_length=200, null=False)
    file = models.FileField('File path', upload_to=service_sample_directory, null=True, blank=True)
    input = models.ForeignKey('BaseInput', on_delete=models.CASCADE, related_name='input_samples',
                              help_text='Associated input')
    service = models.ForeignKey('Service', on_delete=models.CASCADE, related_name='services_sample', null=True)
    dependent_input = models.ForeignKey('ServiceInput',
                                        on_delete=models.SET_NULL, null=True, blank=True,
                                        help_text='Dependent on another input value')
    when_value = models.CharField('Depending on input value', max_length=255, null=True, blank=True,
                                  help_text='For dependency, related value')

src/waves/api/views/categories.py
from __future__ import unicode_literals

from rest_framework import viewsets

from waves.models import ServiceCategory
from waves.api.serializers import CategorySerializer
from . import WavesBaseView


class CategoryViewSet(viewsets.ReadOnlyModelViewSet, WavesBaseView):
    """
    API entry point to list services categories
    """
    queryset = ServiceCategory.objects.all()
    serializer_class = CategorySerializer
    lookup_field = 'name'

src/waves/api/views/jobs.py
from __future__ import unicode_literals
import logging

from django.shortcuts import get_object_or_404
from rest_framework import viewsets, mixins
from rest_framework.parsers import MultiPartParser, JSONParser
from rest_framework.response import Response
from rest_framework.decorators import detail_route, list_route

from waves.models import Job
from waves.api.serializers.jobs import JobSerializer, JobHistoryDetailSerializer, \
    JobInputDetailSerializer, JobOutputDetailSerializer
from . import WavesBaseView

logger = logging.getLogger(__name__)


class JobViewSet(mixins.ListModelMixin, mixins.RetrieveModelMixin, mixins.DestroyModelMixin,
                 viewsets.GenericViewSet, WavesBaseView):
    """
    API entry point for ServiceJobs
    """
    queryset = Job.objects.all()
    serializer_class = JobSerializer
    parser_classes = (MultiPartParser, JSONParser)
    lookup_field = 'slug'

    def get_queryset(self):
        return Job.objects.all()

    def list(self, request, *args, **kwargs):
        queryset = Job.objects.get_user_job(user=request.user)
        serializer = JobSerializer(queryset,
                                   many=True,
                                   context={'request': request},
                                   fields=('url', 'created', 'status', 'service'))
        return Response(serializer.data)

    def retrieve(self, request, slug=None, *args, **kwargs):
        queryset = Job.objects.get_user_job(user=request.user)
        service_job = get_object_or_404(queryset,
                                        slug=slug)
        serializer = JobSerializer(service_job,
                                   context={'request': request})
        return Response(serializer.data)

    def destroy(self, request, slug=None, *args, **kwargs):
        queryset = Job.objects.get_user_job(user=request.user)
        service_job = get_object_or_404(queryset, slug=slug)
        return Response(self.get_serializer(request=request).data)

    def update(self, request, slug=None):
        return Response(self.get_serializer(request=request).data)

    def partial_update(self, request, slug=None):
        return Response(self.get_serializer(request=request).data)

    @detail_route(methods=['get'], url_path='history')
    def list_history(self, request, slug=None):
        queryset = Job.objects.get_user_job(user=request.user)
        job = get_object_or_404(queryset, slug=slug)
        serializer = JobHistoryDetailSerializer(job,
                                                many=False,
                                                context={'request': request})
        return Response(serializer.data)

    @detail_route(methods=['get'], url_path='inputs')
    def list_inputs(self, request, slug=None):
        queryset = Job.objects.get_user_job(user=request.user)
        job = get_object_or_404(queryset, slug=slug)
        serializer = JobInputDetailSerializer(job,
                                              many=False,
                                              context={'request': request})
        return Response(serializer.data)

    @detail_route(methods=['get'], url_path='outputs')
    def list_outputs(self, request, slug=None):
        queryset = Job.objects.get_user_job(user=request.user)
        job = get_object_or_404(queryset, slug=slug)
        serializer = JobOutputDetailSerializer(job,
                                               many=False,
                                               context={'request': request})
        return Response(serializer.data)

src/waves/api/views/services.py
from __future__ import unicode_literals
from django.shortcuts import get_object_or_404
from rest_framework import viewsets, permissions
from rest_framework.response import Response
from rest_framework import status
from rest_framework.decorators import detail_route, list_route

from waves.models import Service, ServiceInput, Job
from waves.exceptions import JobException
from waves.api.serializers import InputSerializer, ServiceSerializer, ServiceJobSerializer, JobSerializer
from . import WavesBaseView

import logging

logger = logging.getLogger(__name__)


class ServiceInputViewSet(viewsets.ReadOnlyModelViewSet, WavesBaseView):
    """
    Api entry point to ServiceInputs
    """
    serializer_class = InputSerializer

    def get_queryset(self):
        return ServiceInput.objects.filter(tool__pk=self.kwargs['service'],
                                           conditionalqsdqsdinput=None,
                                           conditionalwhen=None)


class ServiceViewSet(viewsets.ReadOnlyModelViewSet, WavesBaseView):
    """
    API entry point to Services
    """
    serializer_class = ServiceSerializer
    lookup_field = 'api_name'

    def get_queryset(self):
        return Service.objects.get_public_services()

    def list(self, request):
        queryset = Service.objects.get_public_services()
        serializer = ServiceSerializer(queryset, many=True, context={'request': request},
                                       fields=('url', 'name', 'short_description', 'version', 'created', 'updated',
                                               'category', 'jobs')
                                       )
        return Response(serializer.data)

    def retrieve(self, request, api_name=None):
        queryset = Service.objects.get_public_services()
        service_tool = get_object_or_404(queryset, api_name=api_name)
        serializer = ServiceSerializer(service_tool, context={'request': request})
        return Response(serializer.data)

    @detail_route(methods=['post', 'get'], url_path='jobs')
    def service_job(self, request, api_name=None):
        if request.POST:
            # CREATE A NEW JOB
            if logger.isEnabledFor(logging.DEBUG):
                for param in request.data:
                    logger.debug('param key ' + param)
                    logger.debug(request.data[param])
                logger.debug('Request Data %s', request.data)
            queryset = Service.objects.get_public_services()
            service = get_object_or_404(queryset, api_name=api_name)
            ass_email = request.data.pop('email', None)
            try:
                request.data.pop('api_key')
                submitted_data = {
                    'service': service.pk,
                    'client': request.user.pk,
                    'inputs': request.data
                }
                # serializer = ServiceJobSerializer(many=False, context={'request': request},data=request.data)
                serializer = self.get_serializer(context={'request': request},
                                                 fields=('inputs',))
                serializer.run_validation(data=submitted_data,)
                job = Service.objects.create_new_job(service=service,
                                                     email_to=ass_email,
                                                     submitted_inputs=request.data,
                                                     user=request.user)
                serializer = JobSerializer(job,
                                           many=False,
                                           context={'request': request},
                                           fields=('slug', 'url', 'created', 'status',))
                return Response(serializer.data, status=201)
            except JobException as e:
                logger.fatal("Create Error %s", e.message)
                return Response({'error': e.message}, status=status.HTTP_400_BAD_REQUEST)
        else:
            # RETRIEVE A SERVICE JOB
            queryset = Service.objects.get_public_services()
            service_tool = get_object_or_404(queryset, api_name=api_name)
            queryset_jobs = Job.objects.get_service_job(user=request.user, service=service_tool)
            serializer = JobSerializer(queryset_jobs,
                                       many=True,
                                       context={'request': request},
                                       fields=('url', 'created', 'status', 'service'))
            return Response(serializer.data)


class ServiceJobViewSet(WavesBaseView):
    serializer_class = ServiceJobSerializer
    pass

src/waves/views/accounts.py
from __future__ import unicode_literals

from braces import views as bracesviews

from authtools import views as authviews
from django.conf import settings
from django.db import transaction
from django.contrib import auth, messages
from django.contrib.auth import get_user_model
from smtplib import SMTPException
from django.core.urlresolvers import reverse_lazy
from django.views import generic

from registration.backends.hmac.views import RegistrationView, ActivationView as BaseActivationView

from waves.forms.accounts import *
import waves.settings
User = get_user_model()


class LoginView(bracesviews.AnonymousRequiredMixin,
                authviews.LoginView):
    template_name = "accounts/login.html"
    form_class = LoginForm

    def form_valid(self, form):
        redirect = super(LoginView, self).form_valid(form)
        remember_me = form.cleaned_data.get('remember_me')
        if remember_me is True:
            one_month = 30 * 24 * 60 * 60
            expiry = getattr(settings, "KEEP_LOGGED_DURATION", one_month)
            self.request.session.set_expiry(expiry)
        return redirect


class LogoutView(authviews.LogoutView):
    url = reverse_lazy('waves:home')

    def get(self, *args, **kwargs):
        auth.logout(self.request)
        messages.success(self.request,
                         "Your successfully log-out")
        return super(LogoutView, self).get(*args, **kwargs)


class SignUpView(bracesviews.AnonymousRequiredMixin,
                 bracesviews.FormValidMessageMixin,
                 generic.CreateView,
                 RegistrationView):
    form_class = SignupForm
    model = User
    template_name = 'accounts/signup.html'
    success_url = reverse_lazy('waves:registration_complete')
    form_valid_message = "You are now registered, don't forget to activate !"
    email_body_template = 'accounts/emails/activation_email.txt'
    email_subject_template = 'accounts/emails/activation_email_subject.txt'
    disallowed_url = 'waves:registration_disallowed'

    def get_success_url(self, user):
        return ('waves:registration_complete', (), {})

    @transaction.atomic()
    def create_inactive_user(self, form):
        try:
            new_user = super(SignUpView, self).create_inactive_user(form)
            new_user.profile.country = form.cleaned_data.get('country')
            new_user.profile.institution = form.cleaned_data.get('institution')
            new_user.profile.phone = form.cleaned_data.get('phone')
            new_user.profile.comment = form.cleaned_data.get('comment')
            new_user.profile.registered_for_api = form.cleaned_data.get('register_for_api')
            new_user.profile.save()
            return new_user
        except SMTPException as e:
            messages.error(self.request, "Something went wrong with your registration, contact team for more info")
            raise e

    def registration_allowed(self):
        return waves.settings.WAVES_REGISTRATION_ALLOWED


class PasswordChangeView(authviews.PasswordChangeView):
    form_class = PasswordChangeForm
    template_name = 'accounts/password_change.html'
    success_url = reverse_lazy('waves:home')

    def form_valid(self, form):
        form.save()
        messages.success(self.request,
                         "Your password was changed, "
                         "hence you have been logged out. Please re-login")
        return super(PasswordChangeView, self).form_valid(form)


class PasswordResetView(authviews.PasswordResetView):
    form_class = PasswordResetForm
    template_name = 'accounts/password_reset.html'
    success_url = reverse_lazy('waves:password-reset-done')
    subject_template_name = 'accounts/emails/password_reset_subject.txt'
    email_template_name = 'accounts/emails/password_reset_email.html'


class PasswordResetDoneView(authviews.PasswordResetDoneView):
    template_name = 'accounts/password_reset_done.html'


class PasswordResetConfirmView(authviews.PasswordResetConfirmAndLoginView):
    template_name = 'accounts/password_reset_confirm.html'
    form_class = SetPasswordForm


class ActivationView(BaseActivationView):
    template_name = 'accounts/activate.html'

    @transaction.atomic
    def activate(self, *args, **kwargs):
        user = super(ActivationView, self).activate(*args, **kwargs)
        return user

    def get_success_url(self, user):
        return ('waves:registration_activation_complete', (), {})

src/waves/views/base.py
from __future__ import unicode_literals
from django.views import generic


class HomePage(generic.TemplateView):
    template_name = "home.html"


class AboutPage(generic.TemplateView):
    template_name = "about.html"

src/waves/templates/accounts/activate.html
{% extends "home.html" %}

{% block title %}Registration complete{% endblock %}

{% block messages %}
    <div class="messages alert alert-warning alert-dismissible fade in">  <!-- singular -->
        <a class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span></a>
        <p>
            You account is already activated, you may login now with your credentials<br/>
        </p>
    </div>
{% endblock %}

src/waves/templates/accounts/activation_complete.html
{% extends "home.html" %}

{% block title %}Registration complete{% endblock %}

{% block messages %}
    <div class="messages alert alert-success alert-dismissible fade in">  <!-- singular -->
        <a class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span></a>
        <p>
            You account is now activated, you may login now with your credentials<br/>
            We are pleased to account you in {%  include '_brandname.html' %} user's list.
            Thanks again for your interest !
        </p>
    </div>
{% endblock %}

src/waves/templates/accounts/auth_base.html
{% extends "base.html" %}

{% load crispy_forms_tags %}

{% block container %}
    <div id="sec1" class="text-page">
        <div class="container">
            <div class="row">
                <div class="col-md-12 text-center">
                    <h2>{% block form_heading %}{% endblock %}</h2>
                </div>
            </div>
        </div>
    </div>
    <div class="container form-box">
        {% block form %}{% endblock %}
    </div>
{% endblock container %}

src/waves/templates/accounts/logged_out.html
{%  extends 'base.html' %}

src/waves/templates/accounts/login.html
{% extends "accounts/auth_base.html" %}

{% load crispy_forms_tags %}

{% block title %}{{ block.super }}Log In{% endblock %}

{% block form_heading %}Please Log In{% endblock %}

{% block form %}
  {% crispy form %}

  <div class="form-message">
    <p>
      Don't have an account? <a href="{% url 'waves:signup' %}">Sign up</a>.
    </p>
  </div>
{% endblock form %}

src/waves/templates/accounts/password_change.html
{% extends "accounts/auth_base.html" %}

{% load crispy_forms_tags %}

{% block title %}{{ block.super }}Password Change{% endblock %}

{% block form_heading %}Password Change{% endblock %}

{% block form %}
  {% crispy form %}
{% endblock form %}

src/waves/templates/accounts/password_reset.html
{% extends "accounts/auth_base.html" %}

{% load crispy_forms_tags %}

{% block title %}{{ block.super }}Password Reset{% endblock %}

{% block form_heading %}Password Reset{% endblock %}

{% block form %}
  {% crispy form %}
{% endblock form %}

src/waves/templates/accounts/password_reset_confirm.html
{% extends "accounts/auth_base.html" %}

{% load crispy_forms_tags %}

{% block title %}{{ block.super }}Password Change{% endblock %}

{% block form_heading %}Password Change{% endblock %}

{% block form %}
  {% crispy form %}
{% endblock form %}

src/waves/templates/accounts/password_reset_done.html
{% extends "accounts/auth_base.html" %}

{% load crispy_forms_tags %}

{% block title %}{{ block.super }}Password Reset Done{% endblock %}

{% block form_heading %}Password Reset Email Sent{% endblock %}

{% block form %}
<div class="form-message">
  <p>
    Please check your mail. You would have received a password reset mail from us.
  </p>
</div>
{% endblock form %}

src/waves/templates/accounts/registration_closed.html
{% extends 'home.html' %}

{% block messages %}
     <div class="messages alert alert-warning alert-dismissible fade in">  <!-- singular -->
         <a class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span></a>
        Sorry, registration is currently closed.
     </div>
{% endblock %}

src/waves/templates/accounts/registration_complete.html
{% extends "home.html" %}

{% block title %}Registration complete{% endblock %}

{% block messages %}
    <div class="messages alert alert-success alert-dismissible fade in">  <!-- singular -->
        <a class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span></a>
        <p>
            You are now registered in our system, thanks for your interest in our application.<br/>
            Please, check your emails to activate your account and gain access to our API.
        </p>
    </div>
{% endblock %}

src/waves/templates/accounts/signup.html
{% extends "accounts/auth_base.html" %}

{% load crispy_forms_tags %}

{% block title %}{{ block.super }}Sign Up{% endblock %}

{% block form_heading %}Sign up to get access to WAVES'API{% endblock %}

{% block form %}
  <div class="form-message text-right">
    <p>
      Already registered ? <a href="{% url 'waves:login' %}">Log in</a>.<br/>
        All fields are required, except phone and comment.
    </p>
  </div>
  {% crispy form %}
{% endblock form %}